- Qt 5.15
- Qt Quick 3D
- QML Types
- Light QML Type
- Qt Quick 3D | Commercial or GPLv3

# Light QML Type

An uncreatable abstract base type for all lights. More...

Import Statement: | import QtQuick3D 1.15
Inherits: | Node
Inherited By: | AreaLight, DirectionalLight, PointLight, and SpotLight

- List of all members, including inherited members

## Properties

- ambientColor : color
- brightness : real
- castsShadow : bool
- color : color
- scope : Node
- shadowBias : real
- shadowFactor : real
- shadowFilter : real
- shadowMapFar : real
- shadowMapQuality : enumeration

## Detailed Description

Light itself is an uncreatable base for all of its subtypes. The subtypes provide multiple options to determine the style of the light.

See also AreaLight, DirectionalLight, and PointLight.

## Property Documentation

ambientColor : color

The property defines the ambient color applied to materials before being lit by this light. The default value is black, rgb(0, 0, 0).

brightness : real

This property defines an overall multiplier for this light’s effects. The default value is 100.

castsShadow : bool

When this property is enabled, the light will cast shadows. The default value is false.

color : color

This property defines the color applied to models illuminated by this light. The default value is white, rgb(255, 255, 255).

scope : Node

The property allows the selection of a Node in the scene. Only that node and it's children are affected by this light. By default no scope is selected.

shadowBias : real

This property is used to tweak the shadowing effect when when objects are casting shadows on themselves. The value range is [-1.0, 1.0]. Generally value inside [-0.1, 0.1] is sufficient. The default value is 0.

shadowFactor : real

This property determines how dark the cast shadows should be. The value range is [0, 100], where 0 mean no shadows and 100 means the light is fully shadowed. The default value is 5.

shadowFilter : real

This property sets how much blur is applied to the shadows. The default value is 5.

shadowMapFar : real

The property determines the maximum distance for the shadow map. Smaller values improve the precision and effects of the map. The default value is 5000.

shadowMapQuality : enumeration

The property sets the quality of the shadow map created for shadow rendering. Lower quality uses less resources, but produces lower quality shadows while higher quality uses more resources, but produces better quality shadows.

Supported quality values are:

Constant | Description
--- | ---
`Light.ShadowMapQualityLow` | Render shadowmap using 256x256 texture.
`Light.ShadowMapQualityMedium` | Render shadowmap using 512x512 texture.
`Light.ShadowMapQualityHigh` | Render shadowmap using 1024x1024 texture.
`Light.ShadowMapQualityVeryHigh` | Render shadowmap using 2048x2048 texture.

The default value is `Light.ShadowMapQualityLow`